-- =============================================
-- Author		:	FID.Ridwan
-- Create date	:	19-Sept-2020
-- Description	:	Invoice Update
-- Update	: 
-- =============================================
CREATE PROCEDURE [dbo].[SP_INVOICE_SEND_FI_JOURNAL] @USER_ID VARCHAR(20) = 'agan'
	,@PROCESS_ID BIGINT = '202009070019'
	,@INVOICE_NO VARCHAR(MAX)
AS
BEGIN
	DECLARE @IsError CHAR(1) = 'N'
	DECLARE @CURRDT DATE = CAST(GETDATE() AS DATE)
	DECLARE @FUNCTION_ID AS VARCHAR(MAX) = '53002'
		,@MODULE_ID AS VARCHAR(MAX) = '5'
		,@FUNTION_NM AS VARCHAR(MAX) = 'SP Invoice Sending'
		,@MSG_TXT AS VARCHAR(MAX)
		,@MSG_TYPE AS VARCHAR(MAX)
		,@LOG_LOCATION AS VARCHAR(MAX) = 'SP Invoice Sending'
		,@L_ERR AS INT = 0
		,@N_ERR AS INT = 0
		,@PARAM1 AS VARCHAR(MAX)
		,@PARAM2 AS VARCHAR(MAX)
		,@PARAM3 AS VARCHAR(MAX)
		,@query VARCHAR(MAX)
		,@ICSSrvrName NVARCHAR(256)
		,@ICSDBName NVARCHAR(256)

	SET NOCOUNT ON

	BEGIN TRY
		DECLARE @l_v_inv_no BIGINT;

		EXEC dbo.CommonGetMessage 'MPCS00002INF'
			,@MSG_TXT OUTPUT
			,@N_ERR OUTPUT
			,'Invoice Sending'

		INSERT INTO TB_R_LOG_D (
			PROCESS_ID
			,SEQUENCE_NUMBER
			,MESSAGE_ID
			,MESSAGE_TYPE
			,[MESSAGE]
			,LOCATION
			,CREATED_BY
			,CREATED_DATE
			)
		SELECT @PROCESS_ID
			,(
				SELECT MAX(ISNULL(SEQUENCE_NUMBER, 0)) + 1
				FROM dbo.TB_R_LOG_D
				WHERE PROCESS_ID = @PROCESS_ID
				)
			,'MPCS00002INF'
			,'INF'
			,'MPCS00002INF : ' + @MSG_TXT
			,@LOG_LOCATION
			,@USER_ID
			,GETDATE()

		--* Step 1. Get System Master *--
		SELECT @ICSSrvrName = SYSTEM_VALUE
		FROM [TB_M_SYSTEM]
		WHERE FUNCTION_ID = 'IPPCS_TO_ICS'
			AND SYSTEM_CD = 'LINKED_SERVER';

		SELECT @ICSDBName = SYSTEM_VALUE
		FROM [TB_M_SYSTEM]
		WHERE FUNCTION_ID = 'IPPCS_TO_ICS'
			AND SYSTEM_CD = 'DB_NAME';

		--* Step 2. Send FI Header *--
		SET @query = ' 
			INSERT OPENQUERY (' + @ICSSrvrName + ' , ''SELECT DOC_NO
				,DOC_YEAR
				,DOC_DT
				,POSTING_DT
				,DOC_HEADER_TXT
				,SUPP_CD
				,PAYMENT_TERM_CD
				,PAYMENT_METHOD_CD
				,PARTNER_BANK_KEY
				,REFF_NO
				,CREATED_BY
				,CREATED_DT
				,CHANGED_BY
				,CHANGED_DT 
			FROM ' + @ICSDBName + 'TB_R_FI_TRANSACTION_H'')  
			SELECT DOC_NO
				,DOC_YEAR
				,DOC_DT
				,POSTING_DT
				,DOC_HEADER_TXT
				,SUPP_CD
				,PAYMENT_TERM_CD
				,PAYMENT_METHOD_CD
				,PARTNER_BANK_KEY
				,REFF_NO
				,CREATED_BY
				,CREATED_DT
				,CHANGED_BY
				,CHANGED_DT
			FROM TB_R_FI_TRANSACTION_H
			WHERE DOC_NO = ''' + @INVOICE_NO + '''';

		EXEC (@query);

		--* Step 2. Send FI Header *--
		SET @query = ' 
			INSERT OPENQUERY (' + @ICSSrvrName + ' , ''SELECT DOC_NO
				,DOC_YEAR
				,DOC_ITEM
				,CONDITION_TYPE
				,GL_ACCOUNT
				,MAT_NO
				,DOC_QTY
				,DOC_AMT
				,DOC_CURR_CD
				,LOCAL_AMT
				,LOCAL_CURR_CD
				,PO_NO
				,TAX_CD
				,EXCHANGE_RATE
				,VALUATION_CLASS_CD
				,COST_CENTER_CD
				,INTERNAL_ORDER_CD
				,ITEM_TEXT
				,CREATED_BY
				,CREATED_DT
				,CHANGED_BY
				,CHANGED_DT
				,TRANS_TYPE_CD
				,WBS_NO
				,UNIT_OF_MEASURE_CD
			FROM ' + @ICSDBName + 
			'TB_R_FI_TRANSACTION_D'')  
			SELECT DOC_NO
				,DOC_YEAR
				,DOC_ITEM
				,CONDITION_TYPE
				,GL_ACCOUNT
				,MAT_NO
				,DOC_QTY
				,DOC_AMT
				,DOC_CURR_CD
				,LOCAL_AMT
				,LOCAL_CURR_CD
				,PO_NO
				,TAX_CD
				,EXCHANGE_RATE
				,VALUATION_CLASS_CD
				,COST_CENTER_CD
				,INTERNAL_ORDER_CD
				,ITEM_TEXT
				,CREATED_BY
				,CREATED_DT
				,CHANGED_BY
				,CHANGED_DT
				,TRANS_TYPE_CD
				,WBS_NO
				,UNIT_OF_MEASURE_CD
			FROM TB_R_FI_TRANSACTION_D
			WHERE DOC_NO = ''' + @INVOICE_NO + '''';

		EXEC (@query);

		EXEC dbo.CommonGetMessage 'MSPT00005INF'
			,@MSG_TXT OUTPUT
			,@N_ERR OUTPUT
			,'Invoice Sending'

		INSERT INTO TB_R_LOG_D (
			PROCESS_ID
			,SEQUENCE_NUMBER
			,MESSAGE_ID
			,MESSAGE_TYPE
			,[MESSAGE]
			,LOCATION
			,CREATED_BY
			,CREATED_DATE
			)
		SELECT @PROCESS_ID
			,(
				SELECT MAX(ISNULL(SEQUENCE_NUMBER, 0)) + 1
				FROM dbo.TB_R_LOG_D
				WHERE PROCESS_ID = @PROCESS_ID
				)
			,'MSPT00005INF'
			,'INF'
			,'MSPT00005INF : ' + @MSG_TXT
			,@LOG_LOCATION
			,@USER_ID
			,GETDATE()

		RETURN 0;
	END TRY

	BEGIN CATCH
		SET @PARAM1 = CONVERT(VARCHAR(1000), ERROR_MESSAGE());

		EXEC dbo.CommonGetMessage 'MPCS00999ERR'
			,@MSG_TXT OUTPUT
			,@N_ERR OUTPUT
			,@PARAM1

		INSERT INTO TB_R_LOG_D (
			PROCESS_ID
			,SEQUENCE_NUMBER
			,MESSAGE_ID
			,MESSAGE_TYPE
			,[MESSAGE]
			,LOCATION
			,CREATED_BY
			,CREATED_DATE
			)
		SELECT @PROCESS_ID
			,(
				SELECT MAX(ISNULL(SEQUENCE_NUMBER, 0)) + 1
				FROM dbo.TB_R_LOG_D
				WHERE PROCESS_ID = @PROCESS_ID
				)
			,'MPCS00999ERR'
			,'ERR'
			,'MPCS00999ERR : ' + @MSG_TXT
			,@LOG_LOCATION
			,@USER_ID
			,GETDATE()

		RETURN 1;
	END CATCH
END
